import threading
import time
import os
import screenlets
from screenlets import Tooltip, utils, services
import subprocess

class ScreenletsRestarter():
	def __init__(self):
		pr = subprocess.Popen("xdpyinfo | grep \'dimensions\'", shell=True, stdout=subprocess.PIPE)
		arr = pr.stdout.read().split(' ')[6].split('x')
		self.width = int(arr[0])
		self.height = int(arr[1])
		self.ratio = self.width / self.height
		self.changedRatio = 0
	
	def checkResize(self):
		pr = subprocess.Popen("xdpyinfo | grep \'dimensions\'", shell=True, stdout=subprocess.PIPE)
		arr = pr.stdout.read().split(' ')[6].split('x')
		w = int(arr[0])
		h = int(arr[1])
		if(self.width != w or self.height != h):
			self.width = w
			self.height = h
			utils.quit_screenlet_by_name('MultiFolderView')
			while(services.service_is_running('MultiFolderView')):
				pass
			screenlets.launch_screenlet('MultiFolderView')
			if(self.ratio != 0 and (w/h != self.ratio or w <= 800)):
				while(not services.service_is_running('MultiFolderView')):
					pass
				time.sleep(1)
				utils.quit_screenlet_by_name('MultiFolderView')
				while(services.service_is_running('MultiFolderView')):
					pass
				screenlets.launch_screenlet('MultiFolderView')
				self.ratio = w/h
			if(self.ratio == 0):
				self.ratio = w/h
			return 1
		return 0

	def start(self):
		while(1):
			time.sleep(2)
			if(self.checkResize() == 1):
				time.sleep(1)

restarter = ScreenletsRestarter()
restarter.start()
